(******************************************************************************)
(* Corpsman's Delphi Tools                                          ver. 1.03 *)
(*                                                                            *)
(* Es folgt eine Sammlung verschiedenster Befehle, die ich sehr oft Brauche.  *)
(*                                                                            *)
(* Fr schden an Soft, oder Hardware kann ich keine Verantwortung bernehmen *)
(* Der Gebrauch dieser Funcitonen und Procedure erfolgt auf eigene Gefahr.    *)
(*                                                                            *)
(******************************************************************************)

Unit Ctools;

Interface

Uses windows, Sysutils, jpeg, graphics, classes;

Type
  // Type Um Mit Brchen zu Rechnen
  TIQ = Record
    Zaehler, Nenner: Integer;
  End;

  // Sucht aus dem String Data den String heraus der zwischen den Tokensymbolen steht
  // Beginnend mit Tokennumber 0
  // z.b. S := String_Tokenizer('',0,'HalloWelt'); => s = Hallo
Function String_Tokenizer(Tokensymbol: Char; Tokennumber: Integer; Data: String): String;

// Wandelt 4 koordinaten in Trect um
Function ToRect(ALeft, ATop, ARight, ABottom: Integer): TRect;

// Gibt das aktuell vom system benutzten Trennzeicehn von Vorkomma und Nachkomma teil zurck
Function GetfloatSeparator: String;

// Wandelt einen Floatstring in eine Float Zahl um, der Seperator kann explizit angegeben werden.
Function strtofloat2(Value, Seperator: String): real;

// Diese Procedure tut nichst, sie dient nur zum debuggen da der Compiler haltepunkte auf Ihr erlaubt.
Procedure nop;

// erlaubt das Berechnen des Sinus im Grad mas
Function Sinus(E: Extended): Extended;

// erlaubt das Berechnen des CoSinus im Grad mas
Function CoSinus(E: Extended): Extended;

function Hypot(X, Y: Extended): Extended;

// bei eingabe eines DeltaX und DeltaY berechnet der Rechner daraus den Winkel
Function arcTangens(x, y: Extended): Extended;

// erlaubt das Berechnen des Tangens im Grad mas
Function Tangens(Value: Extended): Extended;

// Genau wie Mod nur auch mit Negativen Zahlen
Function Mod2(Value, Modulo: Integer): integer;

// Diese Functionen gibt es eigentlich schon in math.pas aber die einzubinden ist manchmal nicht gewnscht.
Function Min(v1, v2: Byte): byte; Overload;
Function Min(v1, v2: integer): integer; Overload;
Function Min(v1, v2: Int64): int64; Overload;
Function Min(v1, v2: Single): single; Overload;
Function Min(v1, v2: Double): double; Overload;
Function Min(v1, v2: Extended): extended; Overload;
Function Max(v1, v2: Byte): byte; Overload;
Function Max(v1, v2: integer): integer; Overload;
Function Max(v1, v2: int64): int64; Overload;
Function Max(v1, v2: Single): single; Overload;
Function Max(v1, v2: Double): double; Overload;
Function Max(v1, v2: Extended): extended; Overload;

// Genau wie Mod2 nur fr Float Zahlen , Aber Vorsicht der PC hat eine gewisse Ungenauigkeit die die Ergebnisse manchmal deutlich Verflschen
Function Modfloat(Value, Modulo: Extended): Extended;

// Gibt den Rest einer Multiplikation von (X^Y) mod Z zurck
Function XHochYModZ(x, y, z: integer): integer;

// Wandelt eine ZAhl Basis Old_Base in eine Integer Zahl Basis 10 um
Function Base_Convert(Number: String; OLD_Base: Byte): int64; overload;

// Wandelt eine Decimalzahl in eine Zahl der Basis New_base um
Function Base_Convert(Number_Base_10: Int64; New_Base: Byte): String; overload;

// Komprimiert ein jpg File und speichert es unter Newjpgfile wieder ab.
// Compression im Bereuch zwischen 1.. 100
Function Compress(jpgFile, Newjpgfile: String; Compression: integer): Boolean;

// Tauscht 2 Variablen mit einander aus
Procedure Tausche(Var i1, i2: Byte); overload;
Procedure Tausche(Var i1, i2: integer); overload;
Procedure Tausche(Var i1, i2: Int64); overload;
Procedure Tausche(Var i1, i2: Single); overload;
Procedure Tausche(Var i1, i2: Double); overload;
Procedure Tausche(Var i1, i2: Extended); overload;

// Gibt true zurck wenn sich die Ellipsen schneiden
Function Ellipsecollision(E1, E2: Trect): boolean; overload

// Gibt true zurck wenn sich die Kreise schneiden
Function Kreiscollision(P1, P2: Tpoint; R1, R2: integer): boolean; overload

// Gibt true zurck wenn sich die Rechtecke schneiden
Function Rechteckcollision(r1, r2: Trect): boolean; overload

// Gibt true zurck wenn sich die Rechtecke schneiden
Function Rechteckcollision(Left1, Top1, Right1, Bottom1, Left2, Top2, Right2, Bottom2: Integer): boolean; overload

// Gibt True zurck wenn p in R liegt
Function PointRechteckcollision(P: Tpoint; R: Trect): boolean; overload;
Function PointRechteckcollision(P: Tpoint; Left, Top, Right, Bottom: Integer): boolean; overload;
Function PointRechteckcollision(Px, Py, RLeft, RTop, RRight, RBottom: Integer): boolean; overload;
Function PointRechteckcollision(Px, Py: Integer; R: Trect): boolean; overload;

// Gibt true zurck wenn sich die Ellipse mit dem Rechteck schneidet
Function EllipseRechteckcollision(E1, R1: Trect): boolean; overload

// Gibt true zurck wenn sich die Ellipse mit dem Rechteck schneidet
Function EllipseRechteckcollision(Left1, Top1, Right1, Bottom1, Left2, Top2, Right2, Bottom2: Integer): boolean; overload

(*************************** Rechnen mit Brchen ******************************)

// gibt einen Bruch mit Zaehler und Nenner zurck.
Function IQ(Zaehler, Nenner: Integer): TIQ;

// Wandelt einen Strgin in einen Bruch um. z.b. Zaehler / Nenner
Function StringToIQ(Value: String): TIQ;

// Wandelt einen Bruch in einen String Um
Function IQToString(value: Tiq): String;

// Wandelt einen Bruch in eine Gleitkomma Zahl um
Function IQtoFLOAT(Value: TIQ): Real;

// Krzt einen Bruch
Function IQKuerzen(Value: TIQ): TIQ;

// Addiert 2 Brche
Function IQPlusIQ(Value1, Value2: TIQ): TIQ;

// Subtrahiert 2 Brche
Function IQMinusIQ(Value1, Value2: TIQ): TIQ;

// Multipliziert 2 Brche
Function IQMALIQ(Value1, Value2: TIQ): TIQ;

// Teile 2 Brche
Function IQDIVIQ(Value1, value2: TIQ): TIQ;

// Genau gleich wie pos nur von hinten her.
Function PosRueckwaerts(Const Substring, s: String): integer;

(************************ Rechnen mit Brchen  Ende ***************************)

Implementation

function Hypot(X, Y: Extended): Extended;
{ formula: Sqrt(X*X + Y*Y)
  implemented as:  |Y|*Sqrt(1+Sqr(X/Y)), |X| < |Y| for greater precision
var
  Temp: Extended;
begin
  X := Abs(X);
  Y := Abs(Y);
  if X > Y then
  begin
    Temp := X;
    X := Y;
    Y := Temp;
  end;
  if X = 0 then
    Result := Y
  else         // Y > X, X <> 0, so Y > 0
    Result := Y * Sqrt(1 + Sqr(X/Y));
end;
}
asm
        FLD     Y
        FABS
        FLD     X
        FABS
        FCOM
        FNSTSW  AX
        TEST    AH,$45
        JNZ      @@1        // if ST > ST(1) then swap
        FXCH    ST(1)      // put larger number in ST(1)
@@1:    FLDZ
        FCOMP
        FNSTSW  AX
        TEST    AH,$40     // if ST = 0, return ST(1)
        JZ      @@2
        FSTP    ST         // eat ST(0)
        JMP     @@3
@@2:    FDIV    ST,ST(1)   // ST := ST / ST(1)
        FMUL    ST,ST      // ST := ST * ST
        FLD1
        FADD               // ST := ST + 1
        FSQRT              // ST := Sqrt(ST)
        FMUL               // ST(1) := ST * ST(1); Pop ST
@@3:    FWAIT
end;

Function XHochYModZ(x, y, z: integer): integer;
Var
 i: integer;
Begin
  result := 1;
  For i := 1 To y Do Begin
    Result := result * x;
    Result := result Mod z;
  End;
End;

Function String_Tokenizer(Tokensymbol: Char; Tokennumber: Integer; Data: String): String;
Var
  erg: String;
  x, y: Integer;
Begin
  erg := ''; // Initialisieren
  If (Tokennumber >= 0) Then Begin // Nur Positive Tokennummern sind erlaubt.
    erg := Data; // bernehmen der daten.
    // Lschen der Tokens for unserem
    x := 0;
    While x < Tokennumber Do Begin
      inc(x);
      y := Pos(Tokensymbol, erg);
      If y <> 0 Then
        Delete(erg, 1, y)
      Else Begin
        erg := ''; // Sollten gar nicht so viele Tokens da sein abbrechen.
        x := High(integer) - 1;
      End;
    End;
    // Lschen der Token danach.
    y := Pos(Tokensymbol, erg);
    If y <> 0 Then Begin
      Delete(erg, y, length(erg));
    End;
  End;
  result := erg;
End;

Function PosRueckwaerts(Const Substring, s: String): integer;
Var
  x, y: Integer;
  b: boolean;
Begin
  result := 0; // Falls wir den Substring gar nicht finden
  If Length(s) <> 0 Then // Standart Fehler Abfangen
    If Length(Substring) <> 0 Then // Standart Fehler Abfangen
      If Length(s) >= length(substring) Then Begin // Standart Fehler Abfangen
        x := length(s) - Length(substring) + 1; // Die MAximal hinterste Position in s berechnen
        While x > 0 Do Begin // Wir suchen erst mal nur nach den 1. Zeichen ob die stimmen
          If s[x] = Substring[1] Then Begin // Wenn die Stimmen dann schauen wir nach ob der Rest stimmt
            b := true; // initialisieren
            y := 2; // Wir haben das 1. Zeichen schon verglichen, deswegen braucehn wir erst mit 2 beginnen
            While (y <= Length(Substring)) And (b) Do Begin // Wenn wir wissen das es nicht mehr passt knnen wir abbrechen
              If s[x + y - 1] <> Substring[y] Then b := false; // Feststellen ob es passt
              inc(y); // Weiterzhlen nicht vergessen
            End;
            If b Then Begin // Wenn wir die Position gefunden haben brechen wir alles ab.
              result := x;
              exit;
            End;
          End;
          dec(x); // Weiterzhlen nicht vergessen.
        End;
      End;
End;

Function ToRect(ALeft, ATop, ARight, ABottom: Integer): TRect;
Begin
  With Result Do Begin
    Left := ALeft;
    Top := ATop;
    Right := ARight;
    Bottom := ABottom;
  End;
End;

Function Min(v1, v2: Byte): byte;
Begin
  If V1 < v2 Then
    result := v1
  Else
    result := v2;
End;

Function Min(v1, v2: integer): integer;
Begin
  If V1 < v2 Then
    result := v1
  Else
    result := v2;
End;

Function Min(v1, v2: Int64): int64;
Begin
  If V1 < v2 Then
    result := v1
  Else
    result := v2;
End;

Function Min(v1, v2: Single): single;
Begin
  If V1 < v2 Then
    result := v1
  Else
    result := v2;
End;

Function Min(v1, v2: Double): double;
Begin
  If V1 < v2 Then
    result := v1
  Else
    result := v2;
End;

Function Min(v1, v2: Extended): extended;
Begin
  If V1 < v2 Then
    result := v1
  Else
    result := v2;
End;

Function Max(v1, v2: Byte): byte;
Begin
  If V1 > v2 Then
    result := v1
  Else
    result := v2;
End;

Function Max(v1, v2: integer): integer;
Begin
  If V1 > v2 Then
    result := v1
  Else
    result := v2;
End;

Function Max(v1, v2: int64): int64;
Begin
  If V1 > v2 Then
    result := v1
  Else
    result := v2;
End;

Function Max(v1, v2: Single): single;
Begin
  If V1 > v2 Then
    result := v1
  Else
    result := v2;
End;

Function Max(v1, v2: Double): double;
Begin
  If V1 > v2 Then
    result := v1
  Else
    result := v2;
End;

Function Max(v1, v2: Extended): extended;
Begin
  If V1 > v2 Then
    result := v1
  Else
    result := v2;
End;

Procedure Tausche(Var i1, i2: byte);
Var
  i3: Byte;
Begin
  i3 := i1;
  i1 := i2;
  i2 := i3;
End;

Procedure Tausche(Var i1, i2: integer);
Var
  i3: integer;
Begin
  i3 := i1;
  i1 := i2;
  i2 := i3;
End;

Procedure Tausche(Var i1, i2: Int64);
Var
  i3: Int64;
Begin
  i3 := i1;
  i1 := i2;
  i2 := i3;
End;

Procedure Tausche(Var i1, i2: Single);
Var
  i3: Single;
Begin
  i3 := i1;
  i1 := i2;
  i2 := i3;
End;

Procedure Tausche(Var i1, i2: Double);
Var
  i3: Double;
Begin
  i3 := i1;
  i1 := i2;
  i2 := i3;
End;

Procedure Tausche(Var i1, i2: Extended);
Var
  i3: Extended;
Begin
  i3 := i1;
  i1 := i2;
  i2 := i3;
End;

Function EllipseRechteckcollision(E1, R1: Trect): boolean;
Type
  Tpunkt = Record
    X, Y: Extended;
  End;
Var
  SN1, SN2, X, Alpha: extended;
  p1, p2: Tpoint;
  N1, N2: Tpunkt;
  radius1, radius2: integer;
Begin
  result := false;
  If E1.left > E1.right Then tausche(E1.left, E1.right);
  If E1.Top > E1.bottom Then tausche(E1.top, E1.bottom);
  If r1.left > r1.right Then tausche(r1.left, r1.right);
  If r1.Top > r1.bottom Then tausche(r1.top, r1.bottom);
  p1.x := E1.left + ((E1.right - E1.left) Div 2);
  p1.y := E1.top + ((E1.Bottom - E1.top) Div 2);
  p2.x := r1.left + ((r1.right - r1.left) Div 2);
  p2.y := r1.top + ((r1.Bottom - r1.top) Div 2);
  Alpha := arcTangens(p1.x - p2.x, p1.y - p2.y);
  X := Hypot(p1.x - p2.x, p1.y - p2.y);
  Radius1 := p1.x - E1.left;
  Radius2 := p1.y - E1.top; // Radius 1 Horizontal, Radius2 Vertikal
  N1.X := cosinus(alpha) * radius1 + P1.X;
  N1.Y := sinus(Alpha) * radius2 + P1.Y;
  SN1 := Hypot(p1.x - n1.x, p1.y - n1.y);
  Case round(Alpha) Of
    0..45: Begin
        n2.x := R1.right;
        n2.y := round(tangens(alpha) * ((r1.Bottom - p2.y) / 2)) + p2.y;
      End;
    46..90: Begin
        n2.y := R1.top;
        n2.x := round(tangens(alpha - 45) * ((r1.right - p2.x) / 2)) + p2.x;
      End;
    91..135: Begin
        n2.y := R1.top;
        n2.x := round(tangens(alpha - 90) * ((r1.right - p2.x) / 2)) + p2.x;
      End;
    136..225: Begin
        n2.x := r1.left;
        n2.y := round(tangens(alpha) * ((r1.Bottom - p2.y) / 2)) + p2.y;
      End;
    226..270: Begin
        n2.y := r1.bottom;
        n2.x := round(tangens(alpha - 225) * ((r1.right - p2.x) / 2)) + p2.x;
      End;
    271..315: Begin
        n2.y := r1.bottom;
        n2.x := round(tangens(alpha - 270) * ((r1.right - p2.x) / 2)) + p2.x;
      End;
    316..360: Begin
        n2.x := R1.right;
        n2.y := round(tangens(alpha) * ((r1.Bottom - p2.y) / 2)) + p2.y;
      End;
  End;
  SN2 := Hypot(p2.x - n2.x, p2.y - n2.y);
  If (x <= (sn1 + Sn2)) Then result := true;
End;

Function EllipseRechteckcollision(Left1, Top1, Right1, Bottom1, Left2, Top2, Right2, Bottom2: Integer): boolean;
Begin
  result := ellipseRechteckcollision(rect(left1, top1, right1, bottom1), rect(left2, top2, right2, bottom2));
End;

Function Ellipsecollision(P1, P2: Tpoint; R1, R2, R3, R4: integer): boolean; overload
Type
  Tpunkt = Record
    X, Y: Extended;
  End;
Var
  SN1, SN2, X, Alpha: Extended;
  N1, N2: Tpunkt;
Begin
  result := false;
  Alpha := arcTangens(p1.x - p2.x, p1.y - p2.y);
  X := Hypot(p1.x - p2.x, p1.y - p2.y);
  N1.X := cosinus(alpha) * R1 + P1.X;
  N1.Y := sinus(Alpha) * R2 + P1.Y;
  SN1 := Hypot(p1.x - n1.x, p1.y - n1.y);
  N2.X := cosinus(alpha) * R3 + P2.X;
  N2.Y := sinus(Alpha) * R4 + P2.Y;
  SN2 := Hypot(p2.x - n2.x, p2.y - n2.y);
  If (X <= (SN1 + SN2)) Then result := True;
End;

Function Ellipsecollision(E1, E2: Trect): boolean;
Var
  p1, p2: Tpoint;
  Radius1, radius2, Radius3, radius4: Integer;
Begin
  If E1.left > E1.right Then tausche(E1.left, E1.right);
  If E1.Top > E1.bottom Then tausche(E1.top, E1.bottom);
  If E2.left > E2.right Then tausche(E2.left, E2.right);
  If E2.Top > E2.bottom Then tausche(E2.top, E2.bottom);
  p1.x := E1.left + ((E1.right - E1.left) Div 2);
  p1.y := E1.top + ((E1.Bottom - E1.top) Div 2);
  p2.x := E2.left + ((E2.right - E2.left) Div 2);
  p2.y := E2.top + ((E2.Bottom - E2.top) Div 2);
  Radius1 := p1.x - E1.left;
  Radius2 := p2.x - E2.left;
  Radius3 := p1.y - E1.top;
  Radius4 := p2.y - E2.top;
  If (Radius1 = Radius3) And (Radius2 = Radius4) Then
    result := Kreiscollision(p1, p2, radius1, radius2)
  Else
    result := Ellipsecollision(p1, p2, radius1, radius3, radius2, radius4);
End;

Function Kreiscollision(P1, P2: Tpoint; R1, R2: integer): boolean;
Var
  x: real;
Begin
  result := false;
  x := Hypot(p1.x - p2.x, p1.y - p2.y);
  If (x <= (R1 + R2)) Then result := true;
End;

Function Rechteckcollision(Left1, Top1, Right1, Bottom1, Left2, Top2, Right2, Bottom2: Integer): boolean;
Begin
  result := Rechteckcollision(rect(left1, Top1, Right1, Bottom1), rect(Left2, Top2, Right2, Bottom2));
End;

Function Rechteckscollision(r1, r2: Trect): boolean;
Begin
  result := false;
  If r1.left > r1.right Then tausche(r1.left, r1.right);
  If r1.Top > r1.bottom Then tausche(r1.top, r1.bottom);
  If r2.left > r2.right Then tausche(r2.left, r2.right);
  If r2.Top > r2.bottom Then tausche(r2.top, r2.bottom);
  If (r1.top >= r2.top) And (r1.top <= r2.bottom) And (r1.left >= r2.Left) And (r1.left <= r2.right) Then result := true;
  If (r1.Right >= r2.left) And (r1.right <= r2.right) And (r1.Bottom >= r2.Top) And (r1.bottom <= r2.bottom) Then Result := true;
  If (r1.Bottom >= r2.top) And (r1.bottom <= r2.bottom) And (r1.left >= r2.Left) And (r1.left <= r2.right) Then result := true;
  If (r1.Right >= r2.left) And (r1.right <= r2.right) And (r1.top >= r2.Top) And (r1.top <= r2.bottom) Then Result := true;
End;

Function Rechteckcollision(r1, r2: Trect): boolean;
Begin
  result := false;
  If r1.left > r1.right Then tausche(r1.left, r1.right);
  If r1.Top > r1.bottom Then tausche(r1.top, r1.bottom);
  If r2.left > r2.right Then tausche(r2.left, r2.right);
  If r2.Top > r2.bottom Then tausche(r2.top, r2.bottom);
  If (r1.top >= r2.top) And (r1.top <= r2.bottom) And (r1.left >= r2.Left) And (r1.left <= r2.right) Then result := true;
  If (r1.Right >= r2.left) And (r1.right <= r2.right) And (r1.Bottom >= r2.Top) And (r1.bottom <= r2.bottom) Then Result := true;
  If (r1.Bottom >= r2.top) And (r1.bottom <= r2.bottom) And (r1.left >= r2.Left) And (r1.left <= r2.right) Then result := true;
  If (r1.Right >= r2.left) And (r1.right <= r2.right) And (r1.top >= r2.Top) And (r1.top <= r2.bottom) Then Result := true;
  If Result = false Then result := Rechteckscollision(r2, r1);
End;

Function PointRechteckcollision(P: Tpoint; R: Trect): boolean;
Begin
  result := PointRechteckcollision(p.x, p.y, r.left, r.top, r.right, r.bottom);
End;

Function PointRechteckcollision(P: Tpoint; Left, Top, Right, Bottom: Integer): boolean;
Begin
  result := PointRechteckcollision(p.x, p.y, left, top, right, bottom);
End;

Function PointRechteckcollision(Px, Py, RLeft, RTop, RRight, RBottom: Integer): boolean;
Begin
  If rleft > rright Then tausche(rleft, rright);
  If rTop > rbottom Then tausche(rtop, rbottom);
  result := (px >= rleft) And (px <= rRight) And (py >= rTop) And (py <= rBottom);
End;

Function PointRechteckcollision(Px, Py: Integer; R: Trect): boolean;
Begin
  result := PointRechteckcollision(px, py, r.left, r.top, r.right, r.bottom);
End;

Function Compress(jpgFile, Newjpgfile: String; Compression: integer): Boolean;
Var
  jp: TJpegimage;
  tf: Tfilestream;
  bm: Tbitmap;
  erg: Boolean;
Begin
  // Sicherstellen das compression im Interval 1..100 Liegt
  compression := min(max(1, Compression), 100);
  Try
    erg := true;
    jp := Tjpegimage.create;
    jp.LoadFromfile(jpgfile);
    bm := tbitmap.create;
    bm.assign(jp);
    jp.assign(bm);
    jp.CompressionQuality := Compression;
    tf := tfilestream.Create(Newjpgfile, FMopenWRITE Or FMCREATE);
    jp.SaveToStream(TF);
    tf.free;
    jp.Free;
    bm.free;
  Except
    erg := false;
  End;
  result := erg;
End;

Function Base_Convert(Number_Base_10: Int64; New_Base: Byte): String;
Var
  z: Int64;
  l: Byte;
  s, c: String;
Begin
  s := '';
  z := Number_Base_10;
  While z >= 1 Do Begin
    l := z Mod New_Base;
    If l > 9 Then
      c := chr(l + 55)
    Else
      c := inttostr(L);
    s := c + s;
    z := z Div New_Base;
  End;
  result := s;
End;

Function Base_Convert(Number: String; OLD_Base: Byte): int64;
Var
  x: integer;
  n: int64;
Begin
  Result := 0;
  n := 1;
  For x := length(Number) Downto 1 Do Begin
    If ord(Number[x]) > 55 Then
      Result := result + (ord(Number[x]) - 55) * n
    Else
      Result := result + (ord(Number[x]) - 48) * n;
    n := n * Old_base;
  End;
End;

Function Mod2(Value, Modulo: Integer): integer;
Begin
  If modulo = 0 Then Raise EDivByZero.create('Division durch Null');
  modulo := abs(modulo);
  If Value > 0 Then Begin
    result := Value Mod Modulo;
  End
  Else Begin
    While abs(Value) >= Modulo Do
      value := value + modulo;
    result := value;
  End;
End;

Function Modfloat(Value, Modulo: Extended): Extended;
Begin
  If modulo = 0 Then Raise EDivByZero.create('Division durch Null');
  If Modulo < 0 Then Modulo := -Modulo;
  If Value > 0 Then Begin
    While abs(Value) >= Modulo Do
      value := value - modulo;
    result := value;
  End
  Else Begin
    While Value <= -Modulo Do
      value := value + modulo;
    result := value;
  End;
End;

// Diese Function Krzt den Bruch Value soweit wie mglich !!

Function IQKuerzen(Value: TIQ): TIQ;
Var
  x: integer;
Begin
  Result := Value;
  If ((result.Zaehler < 0) And (result.Nenner < 0)) Or
    ((Result.Nenner < 0) And (result.Zaehler > 0)) Then Begin
    Result.Zaehler := -Result.Zaehler;
    Result.Nenner := -Result.Nenner;
  End;
  If Result.Nenner <> 1 Then Begin
    // Das Offensichtliche Krzen !!
    If abs(Result.Zaehler) Mod abs(Result.Nenner) = 0 Then Begin // 40/20 - > 2/1
      Result.Zaehler := Result.Zaehler Div Result.nenner;
      Result.Nenner := 1;
      exit;
    End;
    // Das Offensichtliche Krzen !!
    // Das Krzen mit dem Grten Gemeinsammen Vielfachen
    If abs(Result.Zaehler) > abs(Result.Nenner) Then Begin
      For x := abs((Result.nenner Div 2)) + 1 Downto 2 Do
        If (abs(Result.Zaehler) Mod x = 0) And (abs(Result.Nenner) Mod x = 0) Then Begin
          Result.Zaehler := (Result.Zaehler Div x);
          Result.Nenner := (Result.Nenner Div x);
          exit;
        End;
    End
    Else Begin
      For x := abs(Result.Zaehler Div 2) + 1 Downto 2 Do
        If (abs(Result.Nenner) Mod x = 0) And (abs(Result.Zaehler) Mod x = 0) Then Begin
          Result.Zaehler := (Result.Zaehler Div x);
          Result.Nenner := (Result.Nenner Div x);
          exit;
        End;
    End;
  End;
  // Das Krzen mit dem Grten Gemeinsammen Vielfachen
End;

// Diese Function Subtrahiert Value1 mit Value 2 in der Menge IQ

Function IQMinusIQ(Value1, Value2: TIQ): TIQ;
Begin
  Value2 := (IQmalIQ(value2, IQ(-1, 1)));
  If Value1.Nenner = Value2.Nenner Then Begin
    Result.Zaehler := Value1.Zaehler + Value2.Zaehler;
    Result.Nenner := Value1.Nenner;
  End
  Else Begin
    // Wenn erst ein gemeinsammer Teiler gefunden werden mu
    Result.Zaehler := Value1.Zaehler * Value2.nenner + Value2.Zaehler * Value1.nenner;
    Result.Nenner := Value1.Nenner * Value2.Nenner;
  End;
  // Das krzen ist immer notwendig
  Result := IQkuerzen(Result);
End;

// Diese Function addiert Value1 mit Value 2 in der Menge IQ

Function IQPlusIQ(Value1, Value2: TIQ): TIQ;
Begin
  If Value1.Nenner = Value2.Nenner Then Begin
    Result.Zaehler := Value1.Zaehler + Value2.Zaehler;
    Result.Nenner := Value1.Nenner;
  End
  Else Begin
    // Wenn erst ein gemeinsammer Teiler gefunden werden mu
    Result.Zaehler := Value1.Zaehler * Value2.nenner + Value2.Zaehler * Value1.nenner;
    Result.Nenner := Value1.Nenner * Value2.Nenner;
  End;
  // Das krzen ist immer notwendig
  Result := IQkuerzen(Result);
End;

// Diese Function nimmt Value1 mit Value2 mal in der Menge IQ

Function IQMALIQ(Value1, Value2: TIQ): TIQ;
Begin
  Result.Zaehler := Value1.Zaehler * Value2.Zaehler;
  Result.Nenner := Value1.Nenner * Value2.Nenner;
  Result := IQKuerzen(Result);
End;

// Die Function Teilt Value1 durch Value2 in der Menge IQ

Function IQDIVIQ(Value1, value2: TIQ): TIQ;
Begin
  Result.Zaehler := Value1.Zaehler * Value2.Nenner;
  Result.Nenner := Value1.Nenner * Value2.Zaehler;
  Result := IQKuerzen(Result);
End;

Function IQtoFLOAT(Value: TIQ): Real;
Begin
  Result := Value.Zaehler / Value.Nenner;
End;

// liefert IQ zurck

Function IQ(Zaehler, Nenner: Integer): TIQ;
Begin
  Result.Zaehler := zaehler;
  Result.Nenner := nenner;
  If nenner = 0 Then Begin
    Result.Nenner := 1;
    Raise EDivByZero.create('Division durch Null');
  End;
End;

// Diese Function gibt Value als String

Function IQToString(value: Tiq): String;
Begin
  If Value.Nenner = 1 Then
    result := inttostr(Value.Zaehler)
  Else
    Result := inttostr(Value.Zaehler) + '/' + inttostr(Value.Nenner);
End;

// Macht aus einem String die Variable IQ
// ist der String ein Integer kein Prob.
// oder Der String ist der Form XX / YY

Function StringToIQ(Value: String): TIQ;
Begin
  If Pos('/', Value) = 0 Then Begin
    result.Zaehler := strtoint(Value);
    result.Nenner := 1;
  End
  Else Begin
    result.Zaehler := strtoint(copy(Value, 1, pos('/', Value) - 1));
    result.Nenner := strtoint(copy(Value, pos('/', Value) + 1, length(Value)));
    If result.nenner = 0 Then Begin
      Result.Nenner := 1;
      Raise EDivByZero.create('Division durch Null');
    End;
  End;
End;

Procedure Nop;
Begin
End;

Function GetfloatSeparator: String;
Var
  f: Real;
  erg: String;
Begin
  f := 1.2;
  erg := floattostr(f);
  erg := copy(erg, pos('1', erg) + 1, pos('2', erg) - pos('1', erg) - 1);
  result := erg;
End;

Function strtofloat2(Value, Seperator: String): Real;
Var
  front, Back, Zahl: String;
Begin
  If Pos(Seperator, value) <> 0 Then Begin
    front := copy(value, 1, pos(Seperator, Value) - 1);
    Back := copy(value, pos(Seperator, Value) + 1, length(value));
    zahl := front + GetfloatSeparator + back;
    result := strtofloat(zahl);
  End
  Else Begin
    // Wenn es gar keine Komma Zahl ist
    result := strtofloat(value);
  End;
End;

function Tan(X: Extended): Extended;
{  Tan := Sin(X) / Cos(X) }
asm
        FLD    X
        FPTAN
        FSTP   ST(0)      { FPTAN pushes 1.0 after result }
        FWAIT
end;

function DegToRad(Degrees: Extended): Extended;  { Radians := Degrees * PI / 180 }
begin
  Result := Degrees * (PI / 180);
end;

function RadToDeg(Radians: Extended): Extended;  { Degrees := Radians * 180 / PI }
begin
  Result := Radians * (180 / PI);
end;


Function Tangens(Value: Extended): Extended;
Begin
  result := tan(degtorad(value));
End;

Function arcTangens(x, y: Extended): Extended;
Begin
  Result := 0;
  If (x = 0) Then Begin
    If (Y >= 0) Then result := 90;
    If (Y < 0) Then result := 270;
  End
  Else Begin
    result := radtodeg(arctan(Y / X));
    If ((X < 0) And (y > 0)) Or ((x < 0) And (Y <= 0)) Then result := 180 + result;
    If (X > 0) And (Y < 0) Then result := 360 + result;
  End;
End;

Function Sinus(E: Extended): Extended;
Begin
  Result := sin(degtorad(e));
End;

Function CoSinus(E: Extended): Extended;
Begin
  Result := cos(degtorad(e));
End;

End.

